# -*- coding: utf-8 -*-
from random import choice
from unicodedata import normalize

from django.shortcuts import render
from django.contrib.auth.decorators import login_required

from adm.models import CSV
from ldap import ncc

@login_required()
def adduser(request):
    ldap = ncc.Ldap()
    admin = ncc.LdapAdmin()
    csv = CSV.objects.all()
    grupos = ldap.listaGrupos()
    caracters = '0123456789ABCDEFGHIJKLMNOPQRSTUVXWYZabcdefghijklmnopqrstuwvxz'

    if request.method == 'POST':
        nome = request.POST.get('nome')
        login = request.POST.get('login')
        email = request.POST.get('email')
        senha = request.POST.get('senha')
        confirmarsenha = request.POST.get('confirmarsenha')
        grupo = request.POST.get('grupo')
        curso = request.POST.get('course')
        matricula = request.POST.get('matricula')

        nome = normalize('NFKD', nome).encode('ASCII', 'ignore').decode('ASCII')
        nome = nome.title()

        login = normalize('NFKD', login).encode('ASCII', 'ignore').decode('ASCII')
        login = login.replace(' ', '')

        if request.POST.get('gesenha') == 'gerar':
            senha = ''
            for char in range(8):
                senha += choice(caracters)
        else:
            if senha != confirmarsenha:
                erro = "Erro ao confirmar senha"
                return render(request, 'adm/adduser.html', locals())
            if len(senha) < 7:
                erro = "Digite uma senha com 7 dígitos no mínimo"
                return render(request, 'adm/adduser.html', locals())

        if ldap.buscaGrupo(grupo) is None:
            erro = "Grupo não existe"
            return render(request, 'adm/adduser.html', locals())
        else:
            buscalogin = ldap.buscaLogin(login)
            if buscalogin is None:
                res = admin.adicionaUsuario(login=login, nome=nome, email=email, grupo=grupo, matricula=matricula,
                                            curso=curso, senha=senha)
                if res:
                    firstname = ""
                    nomes = nome.split(" ")
                    lastname = nomes[-1]
                    listname = nomes[:-1]
                    for k in listname:
                        firstname = firstname + k + " "
                    firstname = firstname[:-1]
                    CSV.objects.create(firstName=nome, lastName=lastname, email=login + "@inf.ufsm.br",
                                       secundario=email, senha=senha)
                    sucesso = "Aluno adicionado com sucesso"
                else:
                    erro = "Erro ao adicionar o usuario "
                    return render(request, 'adm/adduser.html', locals())
            else:
                erro = "Login já existe"
    return render(request, 'adm/adduser.html', locals())