from django.http import HttpResponseRedirect
from django.core.urlresolvers import reverse
from django.shortcuts import render
from django.contrib.auth.decorators import login_required

from ldap import ncc
from unicodedata import normalize

@login_required()
def edit(request, id):
    ldap = ncc.Ldap()
    admin = ncc.LdapAdmin()
    usuario = ldap.buscaLogin(id)
    # grupos
    grupos = ldap.listaGrupos()
    usergroups = []
    for g in grupos:
        if usuario.gidNumber.value == g.gidNumber.value:
            grupobase = g.cn.value
        if 'memberUid' in g:
            if usuario.uid.value in g.memberUid:
                usergroups.append(g.cn.value)
    #validações
    novasenha = ""
    confirmarsenha = ""
    #edição
    if request.method == 'POST':
        if request.POST.get('editarnome'):
            nome = request.POST.get('nome')
            print(usuario.uid.value, nome)
            if len(nome.split(' ')) > 1:
                admin.mudaNome(usuario.uid.value, nome)
                return HttpResponseRedirect(reverse('adm_edit', kwargs={'id': usuario.uid.value}))
            else:
                erro = "Nome invalido"
                return render(request, 'adm/edit.html', locals())
        if request.POST.get('editarsenha'):
            novasenha = request.POST.get('novasenha')
            confirmarsenha = request.POST.get('confirmarsenha')
            if len(novasenha) < 7:
                erro="Digite uma senha com 7 dígitos no mínimo"
            elif novasenha == confirmarsenha:
                res = admin.mudaSenha(usuario.uid.value, novasenha)
                if res:
                    sucesso = "Senha trocada com sucesso"
                else:
                    erro = "Erro ao trocar a senha"
            else:
                erro = "Erro ao confirmar senha"
            return render(request, 'adm/edit.html', locals())
        if request.POST.get('editargrupobase'):
            grupobase = request.POST.get('grupobase')
            if ldap.buscaGrupo(grupobase):
                admin.mudaGrupo(usuario.uid.value, grupobase)
                return HttpResponseRedirect(reverse('adm_edit', kwargs={'id': usuario.uid.value}))
            else:
                erro = "Grupo não existe"
                return render(request, 'adm/edit.html', locals())
        if request.POST.get('editaremail'):
            email = request.POST.get('email')
            admin.mudaEmail(usuario.uid.value, email)
            return HttpResponseRedirect(reverse('adm_edit', kwargs={'id': usuario.uid.value}))
        if request.POST.get('addmembro'):
            group = request.POST.get('textaddmembro')
            if ldap.buscaGrupo(group):
                admin.adicionaMembro(usuario.uid.value, group)
                return HttpResponseRedirect(reverse('adm_edit', kwargs={'id': usuario.uid.value}))
            else:
                erro = "Grupo não existe"
                return render(request, 'adm/edit.html', locals())
    return render(request, 'adm/edit.html', locals())

@login_required()
def removegroup(request, grupo, login):
    ldap = ncc.LdapAdmin()
    ldap.removeMembro(login, grupo)
    return HttpResponseRedirect(reverse('adm_edit', kwargs={'id': login}))


@login_required()
def buscar(request):
    return render(request, 'adm/buscar.html', locals())

@login_required()
def buscar_read(request, id=None):
    if id is None:
        buscar = request.POST.get('busca')
    else:
        buscar = id
    if buscar is not None:
        buscar = normalize('NFKD', buscar).encode('ASCII', 'ignore').decode('ASCII')
        buscar = buscar.title()
        buscar2 = buscar.lower()
    x = ncc.Ldap()  # x=conexao com o ldap
    ldap = x.listaUsuarios()
    grupos = x.listaGrupos()
    for g in grupos:
        if buscar == g.cn.value or buscar2 == g.cn.value:
            grupobusca = g.gidNumber.value
            grupo = g
    return render(request, 'adm/buscar_read.html', locals())

