
from django.shortcuts import render
from django.http import HttpResponseRedirect
from django.core.urlresolvers import reverse
from django.shortcuts import get_object_or_404
from django.http import HttpResponse
from django.contrib.auth.decorators import login_required
from django.core.mail import send_mail

from adm.models import CSV
import csv

@login_required()
def csvImport(request):
    return render(request, "adm/csv_import.html", locals())

@login_required()
def csv_index(request):
    lista_add = CSV.objects.all()
    if request.GET.get('gerar'):
        # Create the HttpResponse object with the appropriate CSV header.
        response = HttpResponse(content_type='text/csv')
        response['Content-Disposition'] = 'attachment; filename="usuarios_google.csv"'
        writer = csv.writer(response)
        writer.writerow(['First Name', 'Last Name', 'Email Address', 'Password'])
        for u in lista_add:
            writer.writerow([u.firstName, u.lastName, u.email, u.senha])
        return response
    if request.GET.get('email'):
        username = request.user.username
        enviados = 0
        origem = username+'@inf.ufsm.br'
        for u in lista_add:
            titulo = "Credenciais do NCC/UFSM"
            corpo = "Olá, " + u.firstName.split(" ")[0] + ".\nTodo ingressante nos Cursos de (Ciência da Computação - Sistemas de Informação - Pós-Graduação em Ciência da Computação) da UFSM é automaticamente cadastrado no Núcleo de Ciência da Computação (NCC), para acessar serviços como email institucional, laboratórios, acesso remoto a computadores, etc.\n" \
                                            "\nSuas credenciais no NCC são:\n\nUsuário: " + u.email.split('@')[0] + "\nSenha: " + u.senha + " \n\nUsando essas credenciais, você pode acessar seu email institucional em: http://mail.inf.ufsm.br." \
                                                    " Nosso serviço de email é hospedado no Google e, no primeiro acesso, você precisa aceitar os termos de uso. \n" \
                                                    "\nATENÇÃO: de agora em diante, o Curso se comunicará com você pelo email " + u.email.split('@')[0] + "@inf.ufsm.br. " \
                                                    "Você deve ler seu email institucional com frequência ou, se preferir, redirecioná-lo para seu email pessoal. \n" \
                             "\nDúvidas sobre os serviços podem ser esclarecidas pelo email admrede@inf.ufsm.br ou através da Wiki: http://wiki.inf.ufsm.br/ \n" \
                             "\n\n   Atenciosamente Administração NCC"
            destino = [u.secundario, origem]
            if send_mail(titulo, corpo, origem, destino, fail_silently=False):
                enviados += 1
        if enviados == len(lista_add):
            sucesso = "Todos email enviados com sucesso"
        elif len(lista_add) - enviados > 0:
            erro = "Algumas mensagens  foram enviados, mas algumas não foram enviadas"
        else:
            erro = "Nenhuma mensagem foi enviada"
    if request.GET.get('remover'):
        for u in lista_add:
            get_object_or_404(CSV, email=u.email).delete()
        return HttpResponseRedirect(reverse('adm_csv_index'))
    return render(request, 'adm/csv_index.html', locals())