from django.shortcuts import render
from django.http import HttpResponseRedirect
from django.core.urlresolvers import reverse
from django.shortcuts import get_object_or_404
from django.core.exceptions import ObjectDoesNotExist
from django.contrib.auth.decorators import login_required

from adm.models import Usuario
from adm.models import CSV
from ldap import ncc
from random import choice


@login_required()
def read(request):
    caracters = '0123456789ABCDEFGHIJKLMNOPQRSTUVXWYZabcdefghijklmnopqrstuwvxz'
    tabela = []
    index = 0
    ldap = ncc.Ldap()
    grupos = ldap.listaGrupos()
    if request.POST and request.FILES:
        # Le arquivo
        csvfile = request.FILES['csv_file']
        for line in csvfile:
            tabela.append(line.decode("utf-8")[:-1].split(","))
            if len(tabela[index]) != 4:
                erro = "Arquivo CSV inválido, formato requerido: COD_CURSO,MATR_ALUNO,NOME_PESSOA,DESCR_MAIL"
                return render(request, "adm/csv_import.html", locals())
            index += 1
        i = 0
        tabela.pop(0)
        # Gera login
        for nome in tabela:
            nome[2] = nome[2].title()
            lista = nome[2].lower().split(" ")
            login_name = ""
            if (len(lista) > 2):
                for x in lista[:2]:
                    login_name += x[0]
                login_name += lista[-1]
            else:
                login_name += lista[0][0] + lista[1]
            # Gera Senha
            senha = ''
            for char in range(8):
                senha += choice(caracters)
            tabela[i].append(login_name)
            tabela[i].append(senha)
            # salva no Banco
            try:
                Usuario.objects.get(matricula=tabela[i][1])
            except ObjectDoesNotExist:
                usuario = Usuario.objects.create(matricula=tabela[i][1], nome=tabela[i][2], email=tabela[i][3],
                                                 login=tabela[i][4],
                                                 senha=tabela[i][5])
                usuario.save()
            i += 1
    usuario = Usuario.objects.all()
    return render(request, "adm/read.html", locals())


@login_required()
def editlogin(request, id):
    usuarios = Usuario.objects.all()
    usuario = get_object_or_404(Usuario, matricula=id)
    Editado = False
    if request.method == 'POST':
        editado = True
        login2 = request.POST.get('dado')
        usuario.login = login2
        usuario.save()
    return render(request, 'adm/editlogin.html', locals())


@login_required()
def editnome(request, id):
    usuarios = Usuario.objects.all()
    usuario = get_object_or_404(Usuario, matricula=id)
    Editado = False
    if request.method == 'POST':
        editado = True
        nome2 = request.POST.get('dado')
        usuario.nome = nome2
        usuario.save()
    return render(request, 'adm/editnome.html', locals())


@login_required()
def delete(request, id):
    usuario = Usuario.objects.all()
    if id == "000":
        for i in usuario:
            get_object_or_404(Usuario, matricula=i.matricula).delete()
    else:
        get_object_or_404(Usuario, matricula=id).delete()
    return HttpResponseRedirect(reverse('adm_read'))


@login_required()
def addldap(request):
    usuario = Usuario.objects.all()
    csv = CSV.objects.all()
    ldap = ncc.Ldap()
    admin = ncc.LdapAdmin()
    grupoform = request.POST.get('group')
    curso = request.POST.get('course')
    lastname = ""
    if ldap.buscaGrupo(grupoform) is None:
        erro = "Grupo não existe"
        return render(request, 'adm/read.html', locals())
    else:
        for i in usuario:
            buscalogin = ldap.buscaLogin(i.login)
            if buscalogin:
                erro = "Usuario " + i.login + " ja existe, troque o usuario do " + i.nome + " clicando sobre o usuario do mesmo"
            if buscalogin is None:
                res = admin.adicionaUsuario(login=i.login, nome=i.nome, grupo=grupoform, matricula=i.matricula,
                                            curso=curso, email=i.email, senha=i.senha)
                if res:
                    firstname = ""
                    nome = i.nome.split(" ")
                    lastname = nome[-1]
                    listname = nome[:-1]
                    for k in listname:
                        firstname = firstname + k + " "
                    firstname = firstname[:-1]
                    CSV.objects.create(firstName=firstname, lastName=lastname, email=i.login + "@inf.ufsm.br",
                                       secundario=i.email, senha=i.senha)
                    get_object_or_404(Usuario, login=i.login).delete()
                else:
                    erro = "Erro ao adicionar o usuario " + i.nome
    usuario = Usuario.objects.all()
    if usuario is None and csv is not None:
        return HttpResponseRedirect(reverse('csv_index'))
    return render(request, 'adm/read.html', locals())
