import os
from wsgiref.util import FileWrapper

from django.contrib.auth.decorators import login_required
from django.core.files import File
from django.http import FileResponse
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from django.http import JsonResponse
from django.shortcuts import render
import json as json_lib
from django import template
from django.shortcuts import get_object_or_404
from django.shortcuts import redirect
from leitor.models import Maquinas

register = template.Library()

dic = None

def backup_file_from_import(dic):
    with open("maquinas_backup.json", 'w') as fp:
        json_lib.dump(dic, fp, sort_keys=True, indent=4)


def download_file(dic):
    import datetime
    time = datetime.datetime.now()

    completeName = "backup/backup_maquinas_{0}{1}{2}_{3}_{4}_{5}.json".format(str(time.hour), str(time.minute),
                                                                                      str(time.second), str(time.day),
                                                                                      str(time.month), str(time.year))

    completeName = os.path.join(os.path.dirname(os.path.dirname(os.path.abspath(__file__))), completeName)
    file2 = open(completeName, "w")
    json_lib.dump(dic, file2, sort_keys=True, indent=4)
    file2.close()

@login_required()
def index(request):
    return render(request, "leitor/index.html", locals())


@login_required()
def json(request):
    return render(request, "leitor/json_import.html", locals())


@login_required()
def show_machines(request):
    if request.POST:  # and request.FILES:
        if request.FILES:
            file = request.FILES['json_file']
            dic = json_lib.loads(request.FILES['json_file'].read().decode('utf-8-sig'))
            download_file(dic)
        else:
            HttpResponseRedirect((json))

        # filtar o mac
        for i in dic:
            for j in dic[i]['membros']:
                ################################
                try:
                    dic[i]['membros'][j]['alias'] = ','.join(dic[i]['membros'][j]['alias'])
                except:
                    None
                ################################
                try:
                    dic[i]['membros'][j]['mac'] = ','.join(dic[i]['membros'][j]['mac'])
                except:
                    None

        # adicionar maquina

        for i in dic:  # server
            for j in dic[i]['membros']:  # nome da maquina

                maq = Maquinas.objects.create()
                maq.servidor = i
                maq.nome = j
                try:
                    maq.ipfixo = dic[i]['ipfixo']
                except:
                    maq.ipfixo = ""
                try:
                    maq.subnet = dic[i]['subnet']
                except:
                    maq.subnet = ""
                try:
                    maq.ip = dic[i]['membros'][j]['ip']
                except:
                    maq.ip = ""
                try:
                    maq.texto = dic[i]['texto']
                except:
                    maq.texto = ""
                try:
                    ####
                    dic[i]['membros'][j]['mac'].split(',')
                    ####
                    if dic[i]['membros'][j]['mac'] is not '':
                        maq.mac = dic[i]['membros'][j]['mac']
                except:
                    maq.mac = ""
                try:
                    maq.sala = dic[i]['membros'][j]['sala']
                except:
                    maq.sala = ""
                try:
                    maq.responsavel = dic[i]['membros'][j]['responsavel']
                except:
                    maq.responsavel = ""
                try:
                    maq.alias = dic[i]['membros'][j]['alias']
                except:
                    maq.alias = ""

                maq.save()
    Maquinas.objects.filter(servidor="").delete()
    maq = Maquinas.objects.all()
    unique_servers = []
    for i in maq:
        if i.servidor not in unique_servers:
            unique_servers.append(i.servidor)
    return render(request, "leitor/listar.html", locals())


@login_required()
def edit(request):
    id = request.GET.get('id')
    maq = Maquinas.objects.all()
    maq_select = get_object_or_404(Maquinas, id=id)
    mac2 = []
    mac = maq_select.mac
    mac2 = mac.split(',')

    alias2 = []
    alias = maq_select.alias
    alias2 = alias.split(',')

    if request.method == 'POST':

        if request.POST.get('button_mac'):
            mac2.append("00:00:00:00:00:00")
            return render(request, "leitor/edit.html", locals())

        if request.POST.get('button_alias'):
            alias2.append("")
            return render(request, "leitor/edit.html", locals())

        if request.POST.get('voltar'):
            return redirect(show_machines)

        id = request.POST.get('id')
        maq = Maquinas.objects.all()
        maq_select = get_object_or_404(Maquinas, id=id)
        ipnovo = request.POST.get('ip')
        novomac = request.POST.getlist('mac3')
        salanovo = request.POST.get('sala')
        responsavelnovo = request.POST.get('responsavel')
        aliasnovo = request.POST.getlist('alias')
        nomenovo = request.POST.get('nome')

        ###########editar o alias############
        aliasnovo = ','.join(aliasnovo)

        ###########editar o mac##############
        novomac = ','.join(novomac)

        ###########fim#######################
        maq_select.ip = ipnovo
        maq_select.mac = novomac
        maq_select.sala = salanovo
        maq_select.responsavel = responsavelnovo
        maq_select.alias = aliasnovo
        maq_select.nome = nomenovo
        maq_select.save()
        return redirect(show_machines)
    return render(request, "leitor/edit.html", locals())


@login_required()
def remove(request):
    id = request.GET.get('id')
    maq = Maquinas.objects.all()
    maq_select = get_object_or_404(Maquinas, id=id)
    if request.method == 'GET':
        Maquinas.objects.filter(id=id).delete()
    return render(request, "leitor/confirm_delete.html", locals())


@login_required()
def adicionar(request):
    if request.method == 'POST':
        servidornovo = request.POST.get('servidor')
        nomenovo = request.POST.get('nome')
        ipnovo = request.POST.get('ip')
        macnovo = request.POST.get('mac')
        salanovo = request.POST.get('sala')
        responsavelnovo = request.POST.get('responsavel')
        aliasnovo = request.POST.get('alias')
        nova_maquina = Maquinas(ipfixo='true', servidor=servidornovo, nome=nomenovo, ip=ipnovo, mac=macnovo,
                                sala=salanovo, responsavel=responsavelnovo, alias=aliasnovo)
        nova_maquina.save()
        return redirect(show_machines)
    return render(request, "leitor/add.html")


@login_required()
def exportar(request):
    maq = Maquinas.objects.all()
    maq_json = {}

    if request.method == 'POST':

        if request.POST.get('exportar'):
            for i in maq:
                maq_json[i.servidor] = {"subnet": i.subnet, "texto": i.texto, "ip_fixo": i.ipfixo, "membros": {}}
            for j in maq:
                maq_json[j.servidor]['membros'] = {j.nome: {}}
            for m in maq:
                new_alias = m.alias.split(',')
                m.alias = new_alias
                new_mac = m.mac.split(',')
                m.mac = new_mac
                try:
                    if m.ip is not '':
                        maq_json[m.servidor]['membros'][m.nome]['ip'] = m.ip
                    if m.sala is not '':
                        maq_json[m.servidor]['membros'][m.nome]['sala'] = m.sala
                    if m.responsavel is not '':
                        maq_json[m.servidor]['membros'][m.nome]['responsavel'] = m.responsavel
                except:
                    maq_json[m.servidor]['membros'][m.nome] = {"ip": m.ip, "sala": m.sala, "responsavel": m.responsavel}
                try:
                    for num in m.mac:
                        if num is not '':
                            maq_json[m.servidor]['membros'][m.nome]['mac'] = m.mac
                    if m.alias[0] is not '':
                        maq_json[m.servidor]['membros'][m.nome]['alias'] = m.alias
                except:
                    maq_json[m.servidor]['membros'][m.nome] = {"mac": m.mac, "alias": m.alias}

            #SALVA AS MAQUINAS
            response = HttpResponse(content_type='text/json')
            response['Content-Disposition'] = 'attachment; filename="Maquinas.json"'
            json_lib.dump(maq_json, response, sort_keys=True, indent=4)
            Maquinas.objects.all().delete()
            return response

        if request.POST.get('remover'):
            Maquinas.objects.all().delete()
            return redirect(show_machines)

        if request.POST.get('voltar'):
            return redirect(show_machines)

    return render(request, "leitor/json_export.html")
