# -*- coding: utf-8 -*-
from random import choice

from django.contrib.auth.models import Permission
from django.contrib.auth import authenticate, login as auth_login, logout as auth_logout
from django.core.exceptions import ObjectDoesNotExist
from django.core.mail import send_mail
from django.http import HttpResponseRedirect
from django.core.urlresolvers import reverse
from django.shortcuts import render, get_object_or_404
from ldap import ncc
from apps import recaptcha
from login.models import Token


def index(request):
    return render(request, 'login/index.html', locals())

def recovery(request):
    if request.method == 'POST':

        humano = recaptcha.Recaptcha()
        if not humano.validate(request):
            erro='Recaptcha invalido, tente novamente'
            return render(request, 'login/recovery.html/', locals())

        chave=""
        caracters = 'ABCDEFGHIJKLMNOPQRSTUVXWYZabcdefghijklmnopqrstuwvxz'
        email = request.POST.get('email')
        user = email.split('@')[0]

        ldap = ncc.Ldap()
        usuario = ldap.buscaLogin(user)
        if usuario is None:
            erro = "Usuário não existe"

        if email.split('@')[1]=='inf.ufsm.br':
            try:
                Token.objects.get(user=user)
            except ObjectDoesNotExist:
                pass
            else:
                get_object_or_404(Token, user=user).delete()
            for char in range(8):
                chave += choice(caracters)
            token = Token.objects.create(user=user, chave=chave)
            titulo = "Solicitação parar trocar a senha do NCC"
            corpo = "Solicitação para recuperar senha recebida, para gerar uma nova senha clique no link: https://www-ncc.inf.ufsm.br/recovery/"+token.chave
            origem = 'admrede@inf.ufsm.br'
            destino = [email]
            send_mail(titulo, corpo, origem, destino, fail_silently=False)
            sucesso='Email enviado com sucesso'
            return render(request, 'login/recovery.html', locals())
        else:
            erro='Email invalido'
    return render(request, 'login/recovery.html', locals())

def senha(request, id):
    token = get_object_or_404(Token, chave=id)
    admin = ncc.LdapAdmin()
    usuario = admin.buscaLogin(token.user)
    if usuario is not None:
        if request.method == 'POST':
            novasenha = request.POST.get('novasenha')
            confirmarsenha = request.POST.get('confirmarsenha')
            if len(novasenha) < 7:
                erro = "Digite uma senha com 7 dígitos no mínimo"
            elif novasenha == confirmarsenha:
                res = admin.mudaSenha(usuario.uid.value, novasenha)
                if res:
                    sucesso = "Senha trocada com sucesso"
                    get_object_or_404(Token, chave=id).delete()
                else:
                    erro = "Erro ao trocar a senha"
            else:
                erro = "Erro ao confirmar senha"
    else:
        erro="Usuario não existe"
    return render(request, 'login/senha.html', locals())

def login(request):
    erro = ''
    ldap = ncc.Ldap()

    permissionadm = Permission.objects.get(codename='user_admin')

    if request.method == 'POST':
        username = request.POST.get('login')
        password = request.POST.get('senha')
        grupo = ldap.buscaGrupo('admrede')
        usuario = ldap.buscaLogin(username)
        if usuario is None:
            erro = "Usuário não existe"
        else:
            user = authenticate(username=username, password=password)
            if username in grupo.memberUid:
                if user is not None:
                    auth_login(request, user)
                    user.user_permissions.add(permissionadm)
                else:
                    erro = "Erro de autenticação"
            else:
                if user is not None:
                    auth_login(request, user)
                    user.user_permissions.remove(permissionadm)
                else:
                    erro = "Erro de autenticação"
    return render(request,'login/index.html', locals())

def sair(request):
    auth_logout(request)
    return HttpResponseRedirect(reverse('login_index'))