"""
Django settings for ncc project.

Generated by 'django-admin startproject' using Django 1.9.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.9/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.9/ref/settings/
"""

'''
Projeto Desenvolvido por: Cassiano Andrei Schneider, Bolsista NCC, 2016.
Contato: cschneider@inf.ufsm.br
'''

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.9/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '!l8-l&05jk2-q25tk6^b3m8c9mlavgrnb9q$mr%4e^5k_210vg'

GOOGLE_RECAPTCHA_SECRET_KEY = '6LfHaiYUAAAAAOsbid8kxSsI2l0x8QGSVn3e6oCS'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ["127.0.0.1", "127.0.1.1"]

ADMINS = [('Admin', 'admrede@inf.ufsm.br')]

# Application definition
INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'adm',
    'leitor',
    'login',
    'usuario',
]

MIDDLEWARE_CLASSES = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'ncc.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'ncc/templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

STATICFILES_DIRS = [
    os.path.join(BASE_DIR, 'ncc/static')
]

WSGI_APPLICATION = 'ncc.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.9/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
    }
}

# LDAP
LDAP_SERVERS = [
    {
        'host': 'ldap-teste.inf.ufsm.br',
        'port': 389,
        'use_ssl': False,
    }
]

LDAP_SEARCH_BASE = "dc=inf,dc=ufsm,dc=br"
LDAP_USER_SEARCH_FILTER = "(&(uid=%s)(objectClass=posixAccount))"
LDAP_USER_MODEL_USERNAME_FIELD = 'uid'
LDAP_MIN_GROUPS = ["admrede", ]
LDAP_BIND_USER = "cn=admin,dc=inf,dc=ufsm,dc=br"
LDAP_BIND_PWD = "amigao"
LDAP_GROUPS_SEARCH_FILTER = "(&(objectClass=posixGroup))"
LDAP_GROUP_MEMBER_ATTRIBUTE = "member"
LDAP_SUPERUSER_GROUPS = ["CN=admrede,dc=inf,dc=ufsm,dc=br", ]
LDAP_STAFF_GROUPS = ["CN=admrede,dc=inf,dc=ufsm,dc=br", ]
LDAP_GROUPS_MAP = {
    'admrede': "cn=admrede,dc=inf,dc=ufsm,dc=br",
}

LDAP_ATTRIBUTES_MAP = {
    'username': 'uid',
    'password': 'userPassword',
}

AUTHENTICATION_BACKENDS = ("django_auth_ldap3_ad.auth.LDAP3ADBackend",)

#EMAIL
EMAIL_USE_TLS = True
EMAIL_HOST = 'mail-relay.inf.ufsm.br'
EMAIL_HOST_USER = 'admrede@inf.ufsm.br'
EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'

# Password validation
# https://docs.djangoproject.com/en/1.9/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.9/topics/i18n/

LANGUAGE_CODE = 'pt-br'

TIME_ZONE = 'America/Sao_Paulo'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.9/howto/static-files/

STATIC_URL = '/static/'

LOGIN_URL = '/login/'

STATIC_ROOT = os.path.join(BASE_DIR, "static/")