"""ncc URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/1.9/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  url(r'^$', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  url(r'^$', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.conf.urls import url, include
    2. Add a URL to urlpatterns:  url(r'^blog/', include('blog.urls'))
"""
from django.conf.urls import url
from django.contrib import admin


urlpatterns = [
    #admin
    url(r'^admin/', admin.site.urls),

    #login
    url(r'^$', 'login.views.index', name='login_index'),
    url(r'^login/$', 'login.views.login', name='login_login'),
    url(r'^sair/$', 'login.views.sair', name='login_sair'),
    url(r'^recovery/$', 'login.views.recovery', name='login_recovery'),
    url(r'^recovery/(?P<id>\w+)/$', 'login.views.senha', name='login_recovery_senha'),

    #usuariosldap
    url(r'^adm/$', 'adm.views.index', name='adm_index'),
    url(r'^turma/csv/$', 'adm.csv_views.csv_index', name='adm_csv_index'),
    url(r'^turma/read/$', 'adm.turma_views.read', name='adm_read'),
    url(r'^turma/buscar/$', 'adm.busca_views.buscar', name='adm_buscar'),
    url(r'^turma/buscar_read/(?P<id>[a-zA-Z0-9_\-]+)/$', 'adm.busca_views.buscar_read', name='adm_buscar_read'),
    url(r'^turma/buscar_read/$', 'adm.busca_views.buscar_read', name='adm_buscar_read'),
    url(r'^turma/addldap/$', 'adm.turma_views.addldap', name='adm_addldap'),
    url(r'^turma/csvImport/$', 'adm.csv_views.csvImport', name='adm_csvImport'),
    url(r'^turma/grupos/$', 'adm.grupo_views.grupos', name='adm_grupos'),
    url(r'^turma/grupos/delete/(?P<id>\w+)/$', 'adm.grupo_views.deletegroup', name='adm_deletegroup'),
    url(r'^usuario/edit/(?P<id>\w+)/$', 'adm.busca_views.edit', name='adm_edit'),
    url(r'^usuario/removegroup/(?P<grupo>\w+)/(?P<login>\w+)$', 'adm.busca_views.removegroup', name='adm_removegroup'),
    url(r'^usuario/editlogin/(?P<id>\w+)/$', 'adm.turma_views.editlogin', name='adm_editlogin'),
    url(r'^usuario/editnome/(?P<id>\w+)/$', 'adm.turma_views.editnome', name='adm_editnome'),
    url(r'^usuario/delete/(?P<id>\w+)/$', 'adm.turma_views.delete', name='adm_delete'),
    url(r'^usuario/adduser/$', 'adm.adduser_views.adduser', name='adm_adduser'),

    #leitor
    url(r'^maq/$', 'leitor.views.index'),
    url(r'^maq/read/$', 'leitor.views.show_machines'),
    url(r'^maq/json/$', 'leitor.views.json'),
    url(r'^maq/edit/$', 'leitor.views.edit', name = 'edit'),
    url(r'^maq/remove/$', 'leitor.views.remove'),
    url(r'^maq/add/$', 'leitor.views.adicionar'),
    url(r'^maq/export/$', 'leitor.views.exportar'),

    #area do usuario
    url(r'^usr/$', 'usuario.views.index', name='usr_index'),
    url(r'^usr/trocarsenha/(?P<id>\w+)/$', 'usuario.views.senha', name='usr_senha'),
    url(r'^usr/vpn/(?P<id>\w+)/$', 'usuario.views.vpn', name='usr_vpn'),
]
