from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.core.urlresolvers import reverse

from ldap import ncc

from ldap3.core.exceptions import LDAPCursorError

# Create your views here.
@login_required()
def index(request):
    usuario = request.user
    ldap = ncc.Ldap()
    grupo = ldap.buscaGrupo('vpn')
    try:
        if usuario.username in grupo.memberUid:
            vpn = True
        else:
            vpn = False
    except LDAPCursorError:
        vpn = False
    return render(request, 'usuario/index.html', locals())

@login_required()
def senha(request, id):
    admin = ncc.LdapAdmin()
    usuario = admin.buscaLogin(id)
    if request.method == 'POST':
        novasenha = request.POST.get('novasenha')
        confirmarsenha = request.POST.get('confirmarsenha')
        if len(novasenha) < 7:
            erro = "Digite uma senha com 7 dígitos no mínimo"
        elif novasenha == confirmarsenha:
            res = admin.mudaSenha(usuario.uid.value, novasenha)
            if res:
                sucesso = "Senha trocada com sucesso"
            else:
                erro = "Erro ao trocar a senha"
        else:
            erro = "Erro ao confirmar senha"
    return render(request, 'usuario/senha.html', locals())

@login_required()
def vpn(request, id):
    erro = ''
    usuario = request.user
    admin = ncc.LdapAdmin()
    grupo = admin.buscaGrupo('vpn')
    try:
        if id in grupo.memberUid:
            admin.removeMembro(id, 'vpn')
        else:
            admin.adicionaMembro(id, 'vpn')
    except LDAPCursorError:
        admin.adicionaMembro(id, 'vpn')
    return HttpResponseRedirect(reverse('usr_index'))
